From e7b8fcd8b9e84e19f5841472efc60f0021513ac7 Mon Sep 17 00:00:00 2001
From: Kristian Amlie <kristian@amlie.name>
Date: Sat, 5 Oct 2013 16:55:02 +0200
Subject: [PATCH] Make sure shm lock always gets released in
 jack_register_server.

---
 libjack/shm.c |    9 +++++++--
 1 file changed, 7 insertions(+), 2 deletions(-)

diff --git a/libjack/shm.c b/libjack/shm.c
index bdd4a2b..f3401c7 100644
--- a/libjack/shm.c
+++ b/libjack/shm.c
@@ -402,11 +402,14 @@ jack_register_server (const char *server_name, int new_registry)
 			     JACK_SERVER_NAME_SIZE) != 0)
 			continue;	/* no match */
 
-		if (jack_shm_header->server[i].pid == my_pid)
+		if (jack_shm_header->server[i].pid == my_pid) {
+			jack_shm_unlock_registry ();
 			return 0;	/* it's me */
+		}
 
 		/* see if server still exists */
 		if (kill (jack_shm_header->server[i].pid, 0) == 0) {
+			jack_shm_unlock_registry ();
 			return EEXIST;	/* other server running */
 		}
 
@@ -421,8 +424,10 @@ jack_register_server (const char *server_name, int new_registry)
 			break;
 	}
 
-	if (i >= MAX_SERVERS)
+	if (i >= MAX_SERVERS) {
+		jack_shm_unlock_registry ();
 		return ENOSPC;		/* out of space */
+	}
 
 	/* claim it */
 	jack_shm_header->server[i].pid = my_pid;
-- 
1.7.9.5

